; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Remove Empty Directories"
!define PRODUCT_VERSION "2.1"
!define PRODUCT_PUBLISHER "Jonas John"
!define PRODUCT_WEB_SITE "http://www.jonasjohn.de/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\RED2.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

; MUI 1.67 compatible ------
!include "MUI.nsh"

SetCompressor /SOLID lzma

; MUI Settings
!define MUI_ABORTWARNING
;!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
;!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"


; theme:
!define OMUI_THEME "CD-Clean"
; In the moment of writing this, NSIS don't support well Vista icons with PNG compression.
; We provide both, compressed and uncompressed (-nopng) icons.

	!define MUI_ICON "${NSISDIR}\Contrib\MUI Orange Vista Theme\${OMUI_THEME}\installer-nopng.ico"
	!define MUI_UNICON "${NSISDIR}\Contrib\MUI Orange Vista Theme\${OMUI_THEME}\uninstaller-nopng.ico"
 
; MUI Settings / Header
	!define MUI_HEADERIMAGE
	!define MUI_HEADERIMAGE_RIGHT
	!define MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\MUI Orange Vista Theme\${OMUI_THEME}\header-r.bmp"
	!define MUI_HEADERIMAGE_UNBITMAP "${NSISDIR}\Contrib\MUI Orange Vista Theme\${OMUI_THEME}\header-r-un.bmp"
 
; MUI Settings / Wizard		
	!define MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\MUI Orange Vista Theme\${OMUI_THEME}\wizard.bmp"
	!define MUI_UNWELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\MUI Orange Vista Theme\${OMUI_THEME}\wizard-un.bmp"  


!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_RADIOBUTTONS
!insertmacro MUI_PAGE_LICENSE "lgpl.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "Remove Empty Directories"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\RED2.exe"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\readme.txt"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; new:
XPStyle on

!define DOTNET_VERSION "2"

!include "DotNET.nsh"
!include LogicLib.nsh

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "red-v2.1-setup.exe"
InstallDir "$PROGRAMFILES\Remove Empty Directories"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01

  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer

  Push $0
  Push $1
  FindWindow $0 "" "Remove Empty Directories"
  ${If} $0 != 0
    DetailPrint "Closing running RED..."
    IntOp $1 0 + 0
    ${While} $0 != 0
        SendMessage $0 ${WM_CLOSE} 0 0
        DetailPrint "Waiting for RED to close..."
        Sleep 200
        IntOp $1 $1 + 200
        ${If} $1 >= 5000
            MessageBox MB_OKCANCEL "Please close RED before continuing installation." IDCANCEL GiveUp IDOK TryAgain
GiveUp:
            Abort "Installation cancelled by user."
TryAgain:
            IntOp $1 0 + 0
        ${EndIf}
        FindWindow $0 "" Remove Empty Directories
    ${EndWhile}
  ${EndIf}
  Pop $1
  Pop $0
  DetailPrint "Running RED closed..."

  !insertmacro CheckDotNET "2" ;required version is 2

  File "RED2.exe"
  SetOverwrite off
  File "red.config"
  SetOverwrite ifnewer
  File "RED2.exe.manifest"
  File "readme.txt"
  File "lgpl.txt"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Remove Empty Directories.lnk" "$INSTDIR\RED2.exe"
  CreateShortCut "$DESKTOP\Remove Empty Directories.lnk" "$INSTDIR\RED2.exe"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Readme file.lnk" "$INSTDIR\readme.txt"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -AdditionalIcons
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\RED2.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\RED2.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\readme.txt"
  Delete "$INSTDIR\lgpl.txt"
  Delete "$INSTDIR\RED2.exe.manifest"
  Delete "$INSTDIR\red.config"
  Delete "$INSTDIR\RED2.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Readme file.lnk"
  Delete "$DESKTOP\Remove Empty Directories.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Remove Empty Directories.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR"
  
  DeleteRegKey HKCR "Folder\shell\Remove empty dirs"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd